/*
 * Copyright 2015 Luca Beltrame <lbeltrame@kde.org>
 *
 * This file is part of Danbooru Client.
 *
 * Danbooru Client is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Danbooru Client is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Danbooru Client. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef DANBOORU_H
#define DANBOORU_H

#include "libdanbooru_version.h"

#include <QObject>

/**
 * @brief The Danbooru namespace.
 * @file danbooru.h
 *
 **/
namespace Danbooru
{

enum ApiType {
    Danbooru = 16,
    MoeBooru = 32,
    Gelbooru = 64,
    Unknown = 128
    };
    
enum Rating {
    Safe = 256,
    Questionable = 512,
    Explicit = 1024
};

enum Request {
    Post = 2048,
    Pool = 4096,
    Artist = 8192,
    Tag = 16384
};

Q_DECLARE_FLAGS(Ratings, Rating)
Q_DECLARE_OPERATORS_FOR_FLAGS(Danbooru::Ratings)

} // namespace Danbooru

Q_ENUMS(Danbooru::ApiType)
Q_ENUMS(Danbooru::Rating)
Q_ENUMS(Danbooru::Request)
Q_DECLARE_METATYPE(Danbooru::ApiType)
Q_DECLARE_METATYPE(Danbooru::Ratings)
Q_DECLARE_METATYPE(Danbooru::Rating)
Q_DECLARE_METATYPE(Danbooru::Request)



#endif // DANBOORU_H
